#!/bin/bash

get_tool_name() {
    echo "Website Load Time Tester"
}

get_tool_description() {
    echo "Test website load times using HTTP requests"
}

execute_tool() {
    result=""
    if [ -n "$domain" ]; then
        if [[ "$domain" == *$'\n'* ]]; then
            for single_domain in $domain; do
                process_domain "$single_domain"
            done
        else
            process_domain "$domain"
        fi
    else
        result="No domains specified."
    fi

    echo -e "$result"
}

process_domain() {
    local single_domain="$1"
    
    result+="\e[1mDomain:\e[93m $single_domain\e[0m\n"
    
    # Measure initial server response time using curl
    response_time=$(curl -o /dev/null -s -w "%{time_starttransfer}\n" "$single_domain")
    
    # Measure fully loaded time using curl
    fully_loaded_time=$(curl -o /dev/null -s -w "%{time_total}\n" "$single_domain")
    
    result+="\e[1mInitial Server Response Time:\e[0m $response_time seconds\n"
    result+="\e[1mFully Loaded Time:\e[0m $fully_loaded_time seconds\n"
}
